--[[
Name: KittyPurr
Project Revision: 2
File Revision: 2 
Author(s): Netrox (netrox@sourceway.eu)
Website: http://wow.curseforge.com/addons/kittypurr/
SVN: svn://svn.curseforge.net/wow/kittypurr/mainline/trunk
License: All rights reserved.
]]

if select(2, UnitClass("player")) ~= "DRUID" then return end

KittyPurr = CreateFrame('frame')
local KittyPurr = KittyPurr

KittyPurr:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
KittyPurr:RegisterEvent("PLAYER_LOGIN")

local OnUpdate
function KittyPurr:PLAYER_LOGIN(event)
    self.doPrint = false

    self.nextPurr = math.random(10, 60)
    self.Print("Next /purr in ~"..tostring(self.nextPurr).." seconds.")
    
    -- Register Events
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
        
    -- Set OnUpdate Handler
    self:SetScript("OnUpdate", OnUpdate)
end

local lastint = floor(GetTime() + 0.5)
function OnUpdate()
    local self = KittyPurr
	local nowint = floor(GetTime() + 0.5)
	if nowint == lastint then return end
    
    
    if nowint - lastint > self.nextPurr then
        if not self.avoidPvpPurr and self.isCatForm then
            DoEmote("purr", 1)
            self.nextPurr = math.random(10, 60)
            self:Print("Next /purr in ~"..tostring(self.nextPurr).." seconds.")
        end
        lastint = nowint
    end        
end

function KittyPurr:PLAYER_ENTERING_WORLD()
    local inInstance, instanceType = IsInInstance()
    if inInstance and (instanceType == "pvp" or instanceType == "arena") then
        self.avoidPvpPurr = true
        self:Print("avoidPvpPurr == true")
    else
        self.avoidPvpPurr = false
        self:Print("avoidPvpPurr == false")
    end
    -- Check for Cat Form, just to be sure.
    self:UPDATE_SHAPESHIFT_FORM()
end

function KittyPurr:UPDATE_SHAPESHIFT_FORM()
    if UnitAura("player", GetSpellInfo(768)) then
        self.isCatForm = true      
        self:Print("isCatForm == true")
    else
        self.isCatForm = false
        self:Print("isCatForm == false")
    end
end

function KittyPurr:Print(t)
    if self.doPrint then DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99KittyPurr|r: "..tostring(t)) end
end
